import { Result } from "@repo/rdx-utils";
import { z } from "zod/v4";
import { translateZodValidationError } from "../helpers";
import { ValueObject } from "./value-object";

interface ProvinceProps {
  value: string;
}

export class Province extends ValueObject<ProvinceProps> {
  private static readonly MAX_LENGTH = 255;

  protected static validate(value: string) {
    const schema = z
      .string()
      .trim()
      .max(Province.MAX_LENGTH, {
        message: `Province must be at most ${Province.MAX_LENGTH} characters long`,
      });
    return schema.safeParse(value);
  }

  static create(value: string) {
    const valueIsValid = Province.validate(value);

    if (!valueIsValid.success) {
      return Result.fail(
        translateZodValidationError("Province creation failed", valueIsValid.error)
      );
    }
    return Result.ok(new Province({ value }));
  }

  getProps(): string {
    return this.props.value;
  }

  toPrimitive() {
    return this.getProps();
  }

  toString() {
    return String(this.props.value);
  }
}
